#!/usr/local/bin/perl

#
# WEB MART : mart.cgi - 2012/08/12
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);

# Ot@C荞
require './init.cgi';
my %cf = &init;

# f[^󂯎
my %in = &parse_form;

# 
if ($in{mode} eq "raw") { &raw_data; }
elsif ($in{mode} eq "change") { &change; }
&pickup_cart;

#-----------------------------------------------------------
#  JS
#-----------------------------------------------------------
sub pickup_cart {
	# ֎~r
	$in{num}   =~ s/\D//g;
	$in{size}  =~ s/[<>"'&,;]//g;
	$in{color} =~ s/[<>"'&,;]//g;
	$in{code}  =~ s/[<>"'&,;]//g;

	# BACKȂ΁AHTTP_REFERERŎ擾
	$in{back} ||= $ENV{HTTP_REFERER};
	if ($in{back}) {
		&chk_back($in{back});
	} else {
		&error("BACK܂");
	}

	# o^f[^F
	my %cart = &get_data;

	# R[h/ɖ̏ꍇ́ugmFv
	if ($in{code} eq "" && $in{num} eq "") {
		my @cook = &get_cookie;
		&basket(\@cook, \%cart);

	# iR[ĥݖ̓G[
	} elsif ($in{code} eq "" && $in{num}) {
		&error("iR[hsł");

	# i̂ݖ̓G[
	} elsif ($in{code} && $in{num} eq "") {
		&error("i܂");
	}

	# iR[h̐`FbN
	if (!defined($cart{$in{code}})) {
		&error("iR[hu$in{code}v͓o^ĂȂf[^łB<br>Ǘ҂ւ₢킹B");
	}

	# ݌ɊǗ̏ꍇ
	if ($cf{stock}) { &check_stock($in{code}, $in{num}); }

	# NbL[擾
	my @cook = &get_cookie;

	# d`FbN
	my ($flg,@new);
	foreach (@cook) {
		my ($id,$code,$num,$size,$col) = split(/,/);

		# vfꍇ͐ʂ𑫂ށidꍇj
		if ($in{code} eq $code && $in{size} eq $size && $in{color} eq $col) {
			$flg++;
			$num += $in{num};

			$_ = "$id,$code,$num,$size,$col";
		}
		push(@new,$_);
	}
	@cook = @new;

	# dȂΔJS֒ǉ
	if (!$flg) {

		# IDԍ𔭍s
		my ($id) = split(/,/, $cook[0]);
		$id++;

		# JS֒ǉ
		@cook = ("$id,$in{code},$in{num},$in{size},$in{color}", @cook);
	}

	# NbL[i[
	&set_cookie(@cook);

	# JSmF
	&basket(\@cook, \%cart);
}

#-----------------------------------------------------------
#  JSʕ\
#-----------------------------------------------------------
sub basket {
	my ($a_cook,$h_cart) = @_;

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/mart.html") or &error("open err: mart.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- item_begin -->(.+)<!-- item_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		&error("ev[gsł");
	}

	# ieWJ
	my $all = 0;
	my ($body,$cart);
	foreach my $cook (@{$a_cook}) {
		my ($id,$code,$num,$size,$col) = split(/,/, $cook);
		my ($code,$name,$price,$intax,$deli,$dai) = split(/<>/, $h_cart->{$code});

		$cart .= qq|<input type="hidden" name="cart" value="$id;$code;$num;$size;$col">\n|;

		# v/݌v
		my $kei = $price * $num;
		$all += $kei;

		my $sel_num;
		foreach my $i (1 .. $cf{max_select}) {
			if ($num == $i) {
				$sel_num .= qq|<option value="$i" selected>$i\n|;
			} else {
				$sel_num .= qq|<option value="$i">$i\n|;
			}
		}

		# l
		my $memo;
		if ($size) { $memo .= " [$cf{op_size}]$size "; }
		if ($col)  { $memo .= " [$cf{op_color}]$col "; }

		my $tmp = $loop;
		$tmp =~ s/!code!/$code/g;
		$tmp =~ s/!item!/$name/g;
		$tmp =~ s/!num!/num:$id/g;
		$tmp =~ s/<!-- sel_num -->/$sel_num/g;
		$tmp =~ s/!chg!/chg:$id/g;
		$tmp =~ s/!tanka!/&comma($price)/ge;
		$tmp =~ s/!gouka!/&comma($kei)/ge;
		$tmp =~ s/!del!/del:$id/g;
		$tmp =~ s/!memo!/$memo/g;

		$body .= $tmp;
	}

	# u
	foreach ($head,$foot) {
		s/!back!/$in{back}/g;
		s/!all!/&comma($all)/ge;
		s/<!-- cart -->/$cart/g;
		s/!home!/$cf{home}/g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
	}

	# ʕ\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head, $body;

	# tb^
	&footer($foot);
}

#-----------------------------------------------------------
#  J[geύX
#-----------------------------------------------------------
sub change {
	# iR[h
	$in{code} =~ s/[<>"'&,;]//g;

	# ύX/폜{^F
	my ($chg_num,$del_num);
	foreach ( keys(%in) ) {
		if (/^chg:(\d+)/) {
			$chg_num = $1;
			last;
		} elsif (/^del:(\d+)/) {
			$del_num = $1;
			last;
		}
	}

	# NbL[擾
	my @get = &get_cookie;

	my ($mycode,$mynum,@cook);
	foreach (@get) {
		my ($id,$code,$num,$size,$col) = split(/,/);

		# ύX
		if ($chg_num eq $id) {
			$mycode = $code;
			$mynum  = $in{"num:$id"};
			$_ = qq|$id,$code,$in{"num:$id"},$size,$col|;

		# 폜
		} elsif ($del_num eq $id) {
			next;
		}
		push(@cook,$_);
	}

	# ʕύX̏ꍇA݌Ƀ`FbN
	if ($cf{stock} && $chg_num) {
		&check_stock($mycode,$mynum);
	}

	# NbL[i[
	&set_cookie(@cook);

	# JS
	my %cart = &get_data;
	&basket(\@cook,\%cart);
}

#-----------------------------------------------------------
#  pϊ
#-----------------------------------------------------------
sub num_z2h {
	local($_) = @_;

	s/O/0/g;
	s/P/1/g;
	s/Q/2/g;
	s/R/3/g;
	s/S/4/g;
	s/T/5/g;
	s/U/6/g;
	s/V/7/g;
	s/W/8/g;
	s/X/9/g;
	$_;
}

#-----------------------------------------------------------
#  ݌ɐ`FbN
#-----------------------------------------------------------
sub check_stock {
	my ($qcode, $qnum) = @_;

	my ($flg, $zaiko);
	open(IN,"$cf{stkfile}") or &error("open err: $cf{stkfile}");
	while (<IN>) {
		my ($code,$zan) = split(/<>/);

		if ($qcode eq $code) {
			if ($zan - $qnum < 0) {
				$zaiko = $zan;
				$flg++;
				last;
			}
		}
	}
	close(IN);

	# ݌ɂȂ
	if ($flg) {
		&error("ɐ\\󂠂܂B<br>݂̏i͍݌ɐ؂ł(݌ɐ:<b>$zaiko</b>)");
	}
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookieID}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  NbL[s
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	# URLGR[h
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookieID}=$cook\n";
}

