#!/usr/local/bin/perl

#
# WEB MART : order.cgi - 2013/02/08
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use Jcode;
use Crypt::RC4;

# ݒt@C荞
require './init.cgi';
my %cf = &init;

# f[^󂯎
my %in = &parse_form;

# 
if ($in{mode} eq "raw") { &raw_data; }
elsif ($in{mode} eq "addr") { &addr_form; }
elsif ($in{mode} eq "conf") { &conf_form; }
elsif ($in{mode} eq "send") { &send_form; }
&error("sȏł");

#-----------------------------------------------------------
#  Z͉ (Step1)
#-----------------------------------------------------------
sub addr_form {
	# back`FbN
	&chk_back($in{back});

	# f[^
	my @cart = split(/\0/, $in{cart});
	if (@cart == 0) { &error("JS̒gł");	}

	# if[^F
	my %cart = &get_data;

	# JSWJ
	my ($hidden,@cook);
	foreach (@cart) {
		my ($id,$code,$num,$size,$col) = split(/;/);

		# `FbN
		$id =~ s/\D//g;
		$code =~ s/\W//g;
		$num =~ s/\D//g;
		$size =~ s/[<>&"']//g;
		$col  =~ s/[<>&"']//g;

		push(@cook,"$id,$code,$num,$size,$col");

		# ʃp[^p
		$hidden .= qq|<input type="hidden" name="cart" value="$id;$code;$num;$size;$col">\n|;
	}

	# Oʂ̖߂̏ꍇ
	my %c;
	if ($in{job} eq "back") {
		%c = %in;

	# ߂łȂꍇ͌ڋq̃NbL[o
	} else {
		my @cust = &get_cookie;

		# 
		($c{name},$c{kana},$c{email},$c{zip},$c{pref},$c{addr},$c{tel},$c{fax},$c{name2},$c{kana2},$c{zip2},$c{pref2},$c{addr2},$c{tel2},$c{fax2})
			 = &decrypt_cust(@cust);
	}

	# s
	$c{addr}  =~ s/\t/\n/g;
	$c{addr2} =~ s/\t/\n/g;
	$c{memo}  =~ s/\t/\n/g;

	# ŗL̒n悪邩`FbN
	my ($flg, $remark);
	foreach (0 .. $#{$cf{pref}}) {
		my ($prf,$pri) = split(/,/, ${$cf{pref}}[$_]);

		if ($pri > 0) {
			$flg++;
			last;
		}
	}
	if ($flg) { $remark = "(͎ʂŌvZ܂)"; }

	# x@
	my $payment;
	foreach (0 .. $#{$cf{payment}}) {
		my ($pay,$cost) = split(/,/, ${$cf{payment}}[$_]);

		if (($in{payment} eq $_) || ($in{payment} eq "" && $_ == 0)) {
			$payment .= qq|<input type="radio" name="payment" value="$_" checked>$pay<br>\n|;
		} else {
			$payment .= qq|<input type="radio" name="payment" value="$_">$pay<br>\n|;
		}
	}

	# zB
	my $opt_deli;
	foreach (0 .. $#{$cf{deli}}) {
		if ($in{deli} eq $_) {
			$opt_deli .= qq|<option value="$_" selected>${$cf{deli}}[$_]\n|;
		} else {
			$opt_deli .= qq|<option value="$_">${$cf{deli}}[$_]\n|;
		}
	}

	# s{
	my ($opt_pref, $opt_pref2);
	foreach (0 .. $#{$cf{pref}}) {
		my ($pref,$postage) = split(/,/, ${$cf{pref}}[$_]);

		if ($c{pref} eq $_) {
			$opt_pref .= qq|<option value="$_" selected>$pref\n|;
		} else {
			$opt_pref .= qq|<option value="$_">$pref\n|;
		}
		if ($c{pref2} eq $_) {
			$opt_pref2 .= qq|<option value="$_" selected>$pref\n|;
		} else {
			$opt_pref2 .= qq|<option value="$_">$pref\n|;
		}
	}

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/addr.html") or &error("open err: addr.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head, $loop, $foot);
	if ($tmpl =~ /(.+)<!-- item_begin -->(.+)<!-- item_end -->(.+)/s) {
		($head, $loop, $foot) = ($1, $2, $3);
	} else {
		&error("ev[gsł");
	}

	# JSWJ
	my $all = 0;
	my $body;
	foreach my $cook (@cook) {
		my ($id,$code,$num,$size,$col) = split(/,/, $cook);
		my ($code,$name,$price,$intax,$deli,$dai) = split(/<>/, $cart{$code});

		# v/݌v
		my $kei = $price * $num;
		$all += $kei;

		# l
		my $memo;
		if ($size) { $memo .= " [$cf{op_size}]$size "; }
		if ($col)  { $memo .= " [$cf{op_color}]$col "; }

		# o
		my $tmp = $loop;
		$tmp =~ s/!code!/$code/g;
		$tmp =~ s/!item!/$name/g;
		$tmp =~ s/!num!/$num/g;
		$tmp =~ s/!tanka!/&comma($price)/ge;
		$tmp =~ s/!gouka!/&comma($kei)/ge;
		$tmp =~ s/!memo!/$memo/g;
		$body .= $tmp;
	}

	foreach ($head, $foot) {
		s/!home!/$cf{home}/g;
		s/!back!/$in{back}/g;
		s/!all!/&comma($all)/ge;
		s/!remark!/$remark/g;
		s/!payment!/$payment/g;
		s/!mon!/$in{mon}/g;
		s/!day!/$in{day}/g;
		s/!c_(\w+)!/$c{$1}/g;
		s/<!-- option_deli -->/$opt_deli/g;
		s/<!-- option_pref -->/$opt_pref/g;
		s/<!-- option_pref2 -->/$opt_pref2/g;
		s/!renraku!/$in{memo}/g;
		s/<!-- cart -->/$hidden/g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
	}

	# ʓWJ
	print "Content-type: text/html\n\n";
	print $head, $body;

	# tb^
	&footer($foot);
}

#-----------------------------------------------------------
#  mF (Step2)
#-----------------------------------------------------------
sub conf_form {
	# back`FbN
	&chk_back($in{back});

	# 擾
	my @cart = split(/\0/, $in{cart});
	if (@cart == 0) { &error("񂪂܂"); }

	# ͊mF
	&check_input;

	# ҏNbL[i[
	my $cookie;
	if ($in{cook} == 1) {
		# ڋqÍ
		my @cust = &encrypt_cust($in{name},$in{kana},$in{email},$in{zip},$in{pref},$in{addr},$in{tel},$in{fax},$in{name2},$in{kana2},$in{zip2},$in{pref2},$in{addr2},$in{tel2},$in{fax2});;

		# NbL[ۑ
		&set_cookie(@cust);
	}

	# ݌ɔF
	my %zan;
	if ($cf{stock}) {
		open(IN,"$cf{stkfile}") or &error("open err: $cf{stkfile}");
		while (<IN>) {
			my ($id,$zan) = split(/<>/);
			$zan{$id} = $zan;
		}
		close(IN);
	}

	# if[^F
	my %cart = &get_data;

	# JSWJ
	my ($flg,$hidden,$scode,@cook);
	foreach (@cart) {
		my ($id,$code,$num,$size,$col) = split(/;/);

		# `FbN
		$id =~ s/\D//g;
		$code =~ s/\W//g;
		$num =~ s/\D//g;
		$size =~ s/[<>&"']//g;
		$col  =~ s/[<>&"']//g;

		push(@cook,"$id,$code,$num,$size,$col");

		# ʃp[^
		$hidden .= qq|<input type="hidden" name="cart" value="$id;$code;$num;$size;$col">\n|;

		# ݌ɐ`FbN
		if ($cf{stock}) {
			if ($zan{$code} - $num < 0) {
				$scode = $code;
				$flg++;
				last;
			}
		}
	}

	# ݌ɐ؂
	if ($flg) {
		my ($name) = (split(/<>/, $cart{$scode}))[1];
		&error("ϐ\\󂠂܂B<br>u$namev͍݌ɐ؂ł(݂̍݌ɐ:$zan{$scode})<br>A̍̕w悤ł");
	}

	# s{/
	my ($pref2,%pref);
	my $postage = 0;
	my ($pref,$postage) = split(/,/, ${$cf{pref}}[$in{pref}]);
	$pref{pref} = $pref;
	if ($in{pref2} ne "") {
		($pref2,$postage) = split(/,/, ${$cf{pref}}[$in{pref2}]);
		$pref{pref2} = $pref2;
	}

	# x@̎萔
	my ($pay,$cost) = split(/,/, ${$cf{payment}}[$in{payment}]);

	# T[rXtO
	my $serv_flag = 0;

	# zB
	my $deliv;
	if ($in{mon} ne "" && $in{day} ne "") {
		$deliv = "$in{mon}$in{day}<br>";
	}
	if ($in{deli} ne "") { $deliv .= ${$cf{deli}}[$in{deli}]; }

	# X֔ԍ
	$in{zip}  =~ s/(\d{3})(\d{4})/$1-$2/;
	$in{zip2} =~ s/(\d{3})(\d{4})/$1-$2/;

	# ʗpp[^
	my @p = qw|payment mon day deli name kana email zip pref addr tel fax name2 kana2 zip2 pref2 addr2 tel2 fax2 memo|;
	foreach (@p) {
		$hidden .= qq|<input type="hidden" name="$_" value="$in{$_}">\n|;
	}

	# s
	$in{addr}  =~ s/\t/<br>/g;
	$in{addr2} =~ s/\t/<br>/g;
	$in{memo}  =~ s/\t/<br>/g;

	# ev[gǂݍ
	open(IN,"$cf{tmpldir}/conf.html") or &error("open err: conf.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- item_begin -->(.+)<!-- item_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		&error("ev[gsł");
	}

	# JSWJ
	my $all = 0;
	my $gkei = 0;
	my $body;
	foreach my $cook (@cook) {
		my ($id,$code,$num,$size,$col) = split(/,/, $cook);
		my ($code,$name,$price,$intax,$deli,$dai) = split(/<>/, $cart{$code});

		# v/݌v
		my $kei = $price * $num;
		$all += $kei;

		# l
		my $memo;
		if ($size) { $memo .= " [$cf{op_size}]$size "; }
		if ($col)  { $memo .= " [$cf{op_color}]$col "; }

		# o
		my $tmp = $loop;
		$tmp =~ s/!code!/$code/g;
		$tmp =~ s/!item!/$name/g;
		$tmp =~ s/!num!/$num/g;
		$tmp =~ s/!tanka!/&comma($price)/ge;
		$tmp =~ s/!gouka!/&comma($kei)/ge;
		$tmp =~ s/!memo!/$memo/g;
		$body .= $tmp;
	}

	# 
	if ($postage > 0) {
		# T[rXL
		if ($cf{cari_serv} && $cf{cari_serv} <= $all) {
			$postage = 0;
			$serv_flag++;
		}
	}
	$gkei = $all;

	# ݒ肳Ăꍇ
	if (!$serv_flag) { $gkei += $postage; }

	# x萔ݒ肳Ăꍇ
	if ($cost > 0) { $gkei += $cost; }

	foreach ($head, $foot) {
		s/!home!/$cf{home}/g;
		s/!back!/$in{back}/g;
		s/!s_kei!/&comma($all)/ge;
		s/!g_kei!/&comma($gkei)/ge;
		s/!postage!/&comma($postage)/ge;
		s/!cost!/&comma($cost)/ge;
		s/!c_(\w+)!/$in{$1}/g;
		s/!(pref2?)!/$pref{$1}/g;
		s/!renraku!/$in{memo}/g;
		s/!deliv!/$deliv/g;
		s/!payment!/$pay/g;
		s/<!-- hidden -->/$hidden/g;
		s/!order_cgi!/$cf{order_cgi}/g;
	}

	# ʓWJ
	print "Content-type: text/html\n\n";
	print $head, $body;

	# tb^
	&footer($foot);
}

#-----------------------------------------------------------
#  M (Step3)
#-----------------------------------------------------------
sub send_form {
	# 擾
	my @cart = split(/\0/, $in{cart});
	if (@cart == 0) { &error("񂪂܂"); }

	# ͊mF
	&check_input;

	# ݌ɔF
	my %zan;
	if ($cf{stock}) {
		open(IN,"$cf{stkfile}") or &error("open err: $cf{stkfile}");
		while (<IN>) {
			my ($id,$zan) = split(/<>/);
			$zan{$id} = $zan;
		}
		close(IN);
	}

	# zXg/Ԃ擾
	my $host = &get_host;
	my ($date,$mdate) = &get_time;
	$in{date} = $date;
	$in{host} = $host;

	# uEU
	$in{agent} = $ENV{HTTP_USER_AGENT};
	$in{agent} =~ s/[<>&"']//g;

	# ԍ̔
	open(DAT,"+< $cf{numfile}") or &error("open err: $cf{numfile}");
	eval "flock(DAT, 2);";
	my $num = <DAT>;
	seek(DAT, 0, 0);
	print DAT ++$num;
	truncate(DAT, tell(DAT));
	close(DAT);

	# 
	$in{number} = sprintf("%06d", $num);

	# [MIMEGR[h
	my $msub = Jcode->new("[ ($in{name}l)")->mime_encode;

	# [wb_[`
	my $mhead = <<EOM;
Subject: $msub
Date: $mdate
MIME-Version: 1.0
Content-type: text/plain; charset=ISO-2022-JP
Content-Transfer-Encoding: 7bit
X-Mailer: $cf{version}
EOM

	# f[^ǂݎ
	my %cart = &get_data;

	# JSWJ
	my $all = 0;
	my $i = 0;
	$in{order} = '';
	foreach (@cart) {
		my ($id,$code,$num,$size,$col) = split(/;/);
		my ($code,$name,$price,$intax,$deli,$dai) = split(/<>/, $cart{$code});

		# v
		my $kei = $price * $num;
		$all += $kei;

		# ݌Ƀ`FbN
		if ($cf{stock}) {
			if ($zan{$code} - $num < 0) {
				&error("ϐ\\󂠂܂B<br>u$namev͍݌ɐ؂ł(݂̍݌ɐ:$zan{$code})<br>A̍̕w悤ł");
			}
			$zan{$code} -= $num;
		}

		# PvZ
		$price = &comma($price);
		$kei   = &comma($kei);

		$i++;
		$in{order} .= "($i) $code $name";
		$in{order} .= " [$cf{op_color}] $col" if ($col ne "");
		$in{order} .= " [$cf{op_size}] $size" if ($size ne "");
		$in{order} .= "\n";
		$in{order} .= "$price ~ $num = $kei\n";
	}
	$in{order} =~ s/\n$//;

	# zB
	$in{deliv} = '';
	if ($in{mon} ne "" && $in{day} ne "") {
		$in{deliv} = "$in{mon}$in{day}";
		if ($in{deli} ne "") {
			$in{deliv} .= " ${$cf{deli}}[$in{deli}]";
		}
	}

	# s
	$in{addr}  =~ s/\t/\n           /g;
	$in{addr2} =~ s/\t/\n           /g;
	$in{memo}  =~ s/\t/\n           /g;

	# v
	$in{skei} = &comma($all);

	# s{/
	my ($pref,$pref2);
	my $postage = 0;
	my ($pref,$postage) = split(/,/, ${$cf{pref}}[$in{pref}]);
	$in{pref} = $pref;
	if ($in{pref2} ne "") {
		($pref2,$postage) = split(/,/, ${$cf{pref}}[$in{pref2}]);
		$in{pref2} = $pref2;
	}

	# x@̎萔
	my ($pay,$cost) = split(/,/, ${cf{payment}}[$in{payment}]);
	my $q_pay = $in{payment};
	$in{payment} = $pay;

	# ʑ
	my $memo;
	if ($postage > 0) {

		# T[rXL
		$in{postage} = 0;
		if ($cf{cari_serv} && $cf{cari_serv } <= $all) {
			$in{postage} = $postage = 0;
			$in{postage} .= ' (T[rX)';

		# T[rX
		} else {
			$all += $postage;
			$in{postage} = &comma($postage);
		}
	}

	# x萔
	$in{cost} = 0;
	if ($cost > 0) {
		$all += $cost;
		$in{cost} = &comma($cost);
	}

	$in{all} = &comma($all);
	my $money = $all;

	# [{ev[gǏoiǗ҈j
	my $mbody1;
	open(IN,"$cf{tmpldir}/order.txt") or &error("open err: order.txt");
	while( my $data = <IN> ) {
		$data =~ s/!(\w+)!/$in{$1}/g;

		$mbody1 .= $data;
	}
	close(IN);

	# I[_[{ev[gǏoi҈j
	my $mbody2;
	open(IN,"$cf{tmpldir}/mail.txt") or &error("open err: mail.txt");
	while( my $data = <IN> ) {
		$data =~ s/!(\w+)!/$in{$1}/g;

		$mbody2 .= $data;
	}
	close(IN);

	# Op
	my $log = $mbody1;

	# R[hϊ
	Jcode::convert(\$mbody1, 'jis', 'sjis');
	Jcode::convert(\$mbody2, 'jis', 'sjis');

	# ^O
	$mbody1 = &tag($mbody1);
	$mbody2 = &tag($mbody2);

	# sendmailR}h
	my $scmd1 = "$cf{sendmail} -t -i";
	my $scmd2 = "$cf{sendmail} -t -i";
	if ($cf{sendm_f} == 1) {
		$scmd1 .= qq| -f $in{email}|;
		$scmd2 .= qq| -f $cf{master}|;
	}

	# Ǘ҂֑M
	open(MAIL,"| $scmd1") or &error("[Ms");
	print MAIL "To: $cf{master}\n";
	print MAIL "From: $in{email}\n";
	print MAIL "$mhead\n";
	print MAIL "$mbody1\n";
	close(MAIL);

	# ҂֑M
	open(MAIL,"| $scmd2") or &error("[Ms");
	print MAIL "To: $in{email}\n";
	print MAIL "From: $cf{master}\n";
	print MAIL "$mhead\n";
	print MAIL "$mbody2\n";
	close(MAIL);

	# ̃NbL[
	#my $cookie = $cgi->cookie(-name => $cf{cookieID}, -value => '', -expires => '-1y');
	&del_cookie;

	# ݌ɐXV
	if ($cf{stock}) {
		my @data;
		while ( my ($id,$zan) = each(%zan) ) {
			push(@data,"$id<>$zan<>\n");
		}

		open(OUT,"+> $cf{stkfile}") or &error("write err: $cf{stkfile}");
		eval "flock(OUT, 2);";
		print OUT @data;
		close(OUT);
	}

	# Oۑ
	&save_log($date,$in{number},$log);

	# ev[g
	my $zeus_num;
	my $tmplfile = "send.html";
	if ($cf{zeus_serv} >= 1 && $q_pay == $#{$cf{payment}}) {
		$tmplfile = "send-credit.html";
		$zeus_num = $cf{zeus_num};
	} elsif ($cf{zeus_serv} == 2 && $q_pay == $#{$cf{payment}}-1) {
		$tmplfile = "send-bank.html";
		$zeus_num = $cf{zeus_bip};
	}

	# 
	open(IN,"$cf{tmpldir}/$tmplfile") or &error("open err: $tmplfile");
	my $tmpl = join('', <IN>);
	close(IN);

	# u
	$tmpl =~ s/!home!/$cf{home}/g;

	# [EXp
	if ($cf{zeus_serv} > 0) {
		$tmpl =~ s/!zeus_num!/$zeus_num/g;
		$tmpl =~ s/!money!/$money/g;
		$tmpl =~ s/!tel!/$in{tel}/g;
		$tmpl =~ s/!email!/$in{email}/g;
		$tmpl =~ s/!sendid!/$in{number}/g;
	}
	$tmpl =~ s/!order_cgi!/$cf{order_cgi}/g;

	# \
	print "Content-type: text/html\n\n";
	&footer($tmpl);
}

#-----------------------------------------------------------
#  Ԏ擾
#-----------------------------------------------------------
sub get_time {
	my ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0..6];

	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;

	# tH[}bg
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d:%02d",
					$year+1900,$mon+1,$mday,$week[$wday],$hour,$min,$sec);

	# [ptH[}bg
	my $mdate = sprintf("%s, %02d %s %04d %02d:%02d:%02d",
					$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec) . " +0900";

	return ($date,$mdate);
}

#-----------------------------------------------------------
#  zXg擾
#-----------------------------------------------------------
sub get_host {
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}
	$host ||= $addr;

	return $host;
}

#-----------------------------------------------------------
#  Oۑ
#-----------------------------------------------------------
sub save_log {
	my ($date,$num,$log) = @_;

	# su
	$log =~ s/\n/\t/g;
	$log =~ s/ +/ /g;

	# Ot@C`
	my $file = ($date =~ /^(\d{4})\/(\d{2})/) && "$1$2.cgi";

	# ݃`FbN
	my $flg;
	if (-e "$cf{logdir}/$file") { $flg++; }

	# Oǉ
	open(DAT,">> $cf{logdir}/$file") or &error("write err: $file");
	eval "flock(DAT, 2);";
	print DAT "$date<>$num<>$log\n";
	close(DAT);

	# VK̏ꍇ̓p[~bVt^
	chmod(0666, "$cf{logdir}/$file") if (!$flg);
}

#-----------------------------------------------------------
#  ̓`FbN
#-----------------------------------------------------------
sub check_input {
	# s
	$in{addr}  =~ s/\t+$//g;
	$in{addr2} =~ s/\t+$//g;
	$in{memo}  =~ s/\t+$//g;

	# ͊mF
	my $err;
	if ($in{payment} eq "") { $err .= "x@Ił<br>"; }
	if ($in{name} eq "") { $err .= "O͂ł<br>"; }
	if ($in{email} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,}$/) {
		$err .= "dq[̓͂sł<br>";
	}
	if ($in{pref} eq "") { $err .= "s{Ił<br>"; }
	if ($in{addr} eq "") { $err .= "Z͂ł<br>"; }
	if ($in{tel} eq "") { $err .= "dbԍ͂ł<br>"; }
	&error($err) if ($err);
}

#-----------------------------------------------------------
#  ^O
#-----------------------------------------------------------
sub tag {
	local($_) = @_;

	s/&lt;/</g;
	s/&gt;/>/g;
	s/&quot;/"/g;
	s/&amp;/&/g;
	$_;
}

#-----------------------------------------------------------
#  ڋqÍ
#-----------------------------------------------------------
sub encrypt_cust {
	my @cust = @_;

	my @ret;
	foreach (@cust) {
		my $encrypt = RC4($cf{passphrase}, $_);
		$encrypt =~ s/(.)/unpack('H2', $1)/eg;

		push(@ret,$encrypt);
	}
	return @ret;
}

#-----------------------------------------------------------
#  ڋq񕜍
#-----------------------------------------------------------
sub decrypt_cust {
	my @cust = @_;

	my @ret;
	foreach (@cust) {
		s/([0-9A-Fa-f]{2})/pack('H2', $1)/eg;
		my $decrypt = RC4($cf{passphrase}, $_);
		$decrypt =~ s/[&"'<>]//g;

		push(@ret,$decrypt);
	}
	return @ret;
}

#-----------------------------------------------------------
#  NbL[
#-----------------------------------------------------------
sub del_cookie {
	print "Set-Cookie: $cf{cookieID}=; expires=Thu, 01-Jan-1970 00:00:00 GMT;\n";
}

#-----------------------------------------------------------
#  NbL[s
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# tH[}bg
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLGR[h
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookieID2}=$cook; expires=$gmt;";
	print " secure" if ($cf{ssl_cookie});
	print "\n";
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookieID2}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;

		push(@cook,$_);
	}
	return @cook;
}

